// file: IntList.java
// author: Bob Muller
// date: February 23, 2014
//
// Harness code for problem 1 on the S14 midterm exam.
//
public class IntList {
    private int info;
    private IntList next;

    public IntList(int info, IntList next) {
        this.info = info;
        this.next = next;
    }

    public int getInfo()     { return this.info; }
    public IntList getNext() { return this.next; }
    
    public static boolean isEmpty(IntList list) { return list == null; }


    // The problem was to write the following function.
    //
    public static IntList merge(IntList a, IntList b) {
        if (IntList.isEmpty(a))
            return b;
        else
            if (IntList.isEmpty(b))
                return a;
            else {
                int m = a.getInfo(),
                    n = b.getInfo();
                if (m < n)
                    return new IntList(m, IntList.merge(a.getNext(), b));
                else
                    return new IntList(n, IntList.merge(a, b.getNext()));
            }
    }
}
