// file: Pair.java
// author: Bob Muller
// date: February 23, 2014
//
// This is an API for problem 2 for the S14 midterm exam.
//
import java.util.*;

public interface Pair<S extends Comparable<S>, T extends Comparable<T>> {
    public S getLeft();
    public T getRight();
    public String toString();
    public Pair<T, S> swap();
    public int compareTo(Pair<S, T> other);
}
